diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
index 62ced22b3..64924c587 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.IntegerSliderElement;
 import net.minecraft.client.option.OptionEnum;
+import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.lang.I18n;
 
@@ -49,6 +50,10 @@ public class DifficultyOptionComponent extends ButtonComponent {
         this.slider.height = buttonHeight;
 
         this.slider.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
     @Override
     public void init(Minecraft mc){
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
index 158ae6230..f7626ed11 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.SliderElement;
 import net.minecraft.client.option.OptionFloat;
+import net.minecraft.client.render.window.CursorShape;
 
 public class FloatOptionComponent
         extends ButtonComponent
@@ -52,6 +53,10 @@ public class FloatOptionComponent
         this.slider.height = buttonHeight;
 
         this.slider.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
index da9ca3938..c4973a5d8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FramerateOptionComponent.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.OptionRange;
+import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.client.render.window.GameWindowGLFW;
 
 public class FramerateOptionComponent extends ToggleableOptionComponent<Integer>{
@@ -29,6 +30,10 @@ public class FramerateOptionComponent extends ToggleableOptionComponent<Integer>
         this.slider.height = buttonHeight;
 
         this.slider.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
     @Override
     public void init(Minecraft mc){
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
index a4f336d7a..6fe4a74c8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/IntegerOptionComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.option.OptionInteger;
+import net.minecraft.client.render.window.CursorShape;
 
 public class IntegerOptionComponent
     extends ButtonComponent
@@ -37,6 +38,10 @@ public class IntegerOptionComponent
         this.button.height = buttonHeight;
 
         this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
index fcdb14628..9e835cea8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.option.KeyBinding;
+import net.minecraft.client.render.window.CursorShape;
 
 public class KeyBindingComponent
         extends ButtonComponent
@@ -43,11 +44,19 @@ public class KeyBindingComponent
 
         this.keyButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
 
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth - this.clearButton.width && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+
         this.clearButton.xPosition = x + relativeButtonX + this.keyButton.width;
         this.clearButton.yPosition = y + relativeButtonY;
         this.clearButton.enabled = this.keyBinding.isBound();
 
         this.clearButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (this.clearButton.enabled && relativeMouseX >= relativeButtonX + this.keyButton.width && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
 
     public void update() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
index 1bf5b9293..748edd253 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
@@ -61,6 +61,7 @@ public class SearchFieldComponent
         textField.yPosition = y + PADDING;
 
         textField.drawTextBox();
+        textField.updateCursor(mc, x + relativeMouseX, y + relativeMouseY);
 
         clearButton.xPosition = x + width / 2 + textField.width / 2 + 1;
         clearButton.yPosition = y + PADDING - 1;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
index 5807490ca..1c6785694 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/ToggleableOptionComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.IntegerSliderElement;
 import net.minecraft.client.option.OptionToggleable;
+import net.minecraft.client.render.window.CursorShape;
 
 public class ToggleableOptionComponent<E>
         extends ButtonComponent
@@ -57,6 +58,10 @@ public class ToggleableOptionComponent<E>
         this.slider.height = buttonHeight;
 
         this.slider.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
     @Override
     public void init(Minecraft mc){
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
index 4f4ec53ef..fd86d799c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.option.OptionToggleable;
 import net.minecraft.client.option.enums.TooltipStyle;
+import net.minecraft.client.render.window.CursorShape;
 import org.lwjgl.opengl.GL11;
 
 public class TooltipPickerComponent<E>
@@ -30,5 +31,9 @@ public class TooltipPickerComponent<E>
         stringWidth += padding * 2;
         GL11.glColor4f(1, 1, 1, 1);
         this.tooltip.render(this.option.getDisplayStringValue(), x + relativeButtonX + buttonWidth / 2 - stringWidth / 2, y + relativeButtonY + 3 + yOffset, 0, 0);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 95aa3d727..130580447 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui.options.data;
 
-import net.betterthanadventure.utils.BiomeFinder;
 import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.enums.EnumGPUVendor;
@@ -17,13 +16,10 @@ import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Utils;
-import net.minecraft.core.world.World;
 import org.useless.seedviewer.SeedViewerMain;
 import paulscode.sound.SoundSystem;
 
@@ -191,6 +187,7 @@ public abstract class OptionsPages
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keySprint))
             )
             .withComponent(new OptionsCategory("gui.options.page.controls.category.user_interface")
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.forceOnscreenKeyboard))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyInventory))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyChat))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyCommand))
@@ -236,6 +233,7 @@ public abstract class OptionsPages
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleGamma))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyLockRotation))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyScreenshot))
+                .withComponent(new KeyBindingComponent(mc.gameSettings.keyShowConsole))
             )
         );
         TEXTURE_PACKS = register(new OptionsPage("gui.options.page.texture_packs.title", new ItemStack(Items.PAINTING))
@@ -285,6 +283,7 @@ public abstract class OptionsPages
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyLoadChunksQuickly))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.settings")
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.developerMode))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.alphaMenu))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.lockCamera))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.showDebugScreen))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index b7554f350..dd77fcaec 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -164,7 +164,9 @@ public final class PopupScreen
         int popupX = width / 2 - popupWidth / 2;
         int popupY = height / 2 - popupHeight / 2;
 
-        parent.render(-1, -1, partialTick);
+        if (this.parent != null) {
+            parent.render(-1, -1, partialTick);
+        }
 
         drawPopupBackground();
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
index 16672f051..82aa528a4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
@@ -40,6 +40,7 @@ public class TextInputComponent
         this.textField.yPosition = y;
 
         this.textField.drawTextBox();
+        this.textField.updateCursor(Minecraft.getMinecraft(), mouseX, mouseY);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java b/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
index 5ae069048..5e9722250 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
@@ -31,11 +31,17 @@ public class TextFieldEditor
 
     private final ITextField textField;
     private int cursor;
+    private final boolean allowNewline;
 
-    public TextFieldEditor(ITextField textField)
+    public TextFieldEditor(ITextField textField, final boolean allowNewline)
     {
         this.textField = textField;
         this.cursor = textField.getText().length();
+        this.allowNewline = allowNewline;
+    }
+
+    public TextFieldEditor(ITextField textField) {
+        this(textField, false);
     }
 
     public int getCursor()
@@ -177,7 +183,7 @@ public class TextFieldEditor
 
         int remaining = textField.maxLength() - currentText.length();
         if (remaining == 0) return;
-        if (!textField.isCharacterAllowed(c)) return;
+        if (!textField.isCharacterAllowed(c) && (!allowNewline || c != '\n')) return;
         if (cursor > currentText.length()) setCursor(currentText.length());
         if (cursor < 0) setCursor(0);
 
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
index 87ca7b7f4..02a035d99 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
@@ -36,6 +36,8 @@ public class ControllerInput {
     public Button[] buttons;
     public Joystick[] joysticks;
 
+    public boolean hideCursor = false;
+    public boolean lockCursor = false;
     public double cursorX;
     public double cursorY;
 
@@ -114,6 +116,7 @@ public class ControllerInput {
     }
 
     public void moveCursor() {
+        if (lockCursor) return;
         double speed = 300 * Time.delta * (minecraft.gameSettings.controllerMenuSensitivity.value + 0.5f);
 
         cursorX += ((Math.pow(joyLeft.getX(), 3.0f) + joyLeft.getX()) / 2.0f) * speed;
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/IButton.java b/game/client/src/main/java/net/minecraft/client/input/controller/IButton.java
index eaac271f6..00e2bfe88 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/IButton.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/IButton.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.input.controller;
 
+import net.minecraft.client.gui.ControllerGlyphElement;
+
 public interface IButton {
 	
 	public boolean isPressed();
@@ -12,5 +14,5 @@ public interface IButton {
 	
 	public void cancelButtonPress();
 	public int getHoldTime();
-	
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
index 1dc07b9a4..6dc270bb9 100644
--- a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
+++ b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
@@ -19,6 +19,7 @@ import com.b100.xml.element.XmlContentTag;
 import com.b100.xml.element.XmlTag;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.sound.SoundRepository;
 import org.slf4j.Logger;
 
 public class ThreadDownloadResources extends Thread {
@@ -122,6 +123,7 @@ public class ThreadDownloadResources extends Thread {
                 throw new RuntimeException("Error downloading sound file: " + soundEntry.name, e);
             }
         }
+        SoundRepository.reload();
 
         downloading = false;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 9d181f2df..baf5382db 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -100,6 +100,7 @@ public class GameSettings {
 	public OptionBoolean showChunkBorders = new OptionBoolean(this, "showChunkBorders", false);
 	public OptionBoolean showCollisionBoxes = new OptionBoolean(this, "showCollisionBoxes", false);
 	public OptionBoolean swapCraftingButtons = new OptionBoolean(this, "swapCraftingButtons", false);
+	public OptionBoolean forceOnscreenKeyboard = new OptionBoolean(this, "forceOnscreenKeyboard", false);
     public OptionBoolean forceUnicodeFont = new OptionBoolean(this, "forceUnicodeFont", false);
 	public OptionEnum<PlacementMode> placementMode = new OptionEnum<>(this, "placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false);
 	public OptionBoolean discordRichPresence = new OptionBoolean(this, "discordRichPresence", false);
@@ -168,6 +169,7 @@ public class GameSettings {
 	public OptionBoolean mobVariants = new OptionBoolean(this, "mobVariants", true);
 	public OptionEnum<Colorblindness> colorblindnessFix = new OptionEnum<>(this, "colorblindnessFix", Colorblindness.class, Colorblindness.NONE);
 	public OptionBoolean subtitles = new OptionBoolean(this, "subtitles", false);
+	public OptionBoolean developerMode = new OptionBoolean(this, "developerMode", false);
 	public OptionBoolean enableHolidayTextures = new OptionBoolean(this, "enableHolidayTextures", true);
 
 	public KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
@@ -222,6 +224,7 @@ public class GameSettings {
 	public KeyBinding keyToggleOverlay = new KeyBinding("key.toggleOverlay").setDefault(InputDevice.keyboard, KEY_F4);
 	public KeyBinding keyOpenAchievements = new KeyBinding("key.openAchievements");
 	public KeyBinding keyOpenStatistics = new KeyBinding("key.openStatistics");
+	public KeyBinding keyShowConsole = new KeyBinding("key.showConsole").setDefault(InputDevice.keyboard, KEY_GRAVE);
 	public List<KeyBinding> debugsKeys = new ArrayList<>();
 	public KeyBinding keyToggleDebug = new KeyBinding("key.toggleDebug").setDefault(InputDevice.keyboard, KEY_F3);
 	public KeyBinding keyReload = new KeyBinding("key.debug.reload").setDefault(InputDevice.keyboard, KEY_R);
diff --git a/game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
index 01789de76..ff3db3266 100644
--- a/game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
@@ -22,7 +22,9 @@ public class BlockEntityRenderDispatcher
         renderers.put(TileEntityMobSpawner.class, new TileEntityRendererMobSpawner());
         renderers.put(TileEntityMovingPistonBlock.class, new TileEntityRendererMovingPiston());
         renderers.put(TileEntityFlowerJar.class, new TileEntityRendererFlowerJar());
+        renderers.put(TileEntityJarButterfly.class, new TileEntityRendererJarButterfly());
         renderers.put(TileEntityMeshGold.class, new TileEntityRendererMeshGold());
+        renderers.put(TileEntityStatue.class, new TileEntityRendererStatue());
 
         for (TileEntityRenderer<?> tileEntityRenderer : renderers.values())
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index 6b807c251..b033462b0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render;
 import java.util.HashMap;
 import java.util.Map;
 
+import net.minecraft.client.render.entity.*;
 import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.model.ModelChicken;
 import net.minecraft.client.render.model.ModelCow;
@@ -14,6 +15,7 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.animal.MobWolf;
@@ -28,41 +30,11 @@ import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
 import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.item.Items;
 import org.lwjgl.opengl.GL11;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.entity.MobRendererZombieArmored;
-import net.minecraft.client.render.entity.EntityRendererArrow;
-import net.minecraft.client.render.entity.EntityRendererBoat;
-import net.minecraft.client.render.entity.EntityRendererFishingBobber;
-import net.minecraft.client.render.entity.EntityRendererCannonball;
-import net.minecraft.client.render.entity.MobRendererChicken;
-import net.minecraft.client.render.entity.MobRendererCow;
-import net.minecraft.client.render.entity.MobRendererCreeper;
-import net.minecraft.client.render.entity.EntityRendererDefault;
-import net.minecraft.client.render.entity.EntityRenderer;
-import net.minecraft.client.render.entity.EntityRendererFallingBlock;
-import net.minecraft.client.render.entity.MobRendererFireflyCluster;
-import net.minecraft.client.render.entity.MobRendererGhast;
-import net.minecraft.client.render.entity.MobRendererGiant;
-import net.minecraft.client.render.entity.EntityRendererItem;
-import net.minecraft.client.render.entity.EntityRendererLightningBolt;
-import net.minecraft.client.render.entity.MobRenderer;
-import net.minecraft.client.render.entity.EntityRendererMinecart;
-import net.minecraft.client.render.entity.MobRendererBiped;
-import net.minecraft.client.render.entity.MobRendererHuman;
-import net.minecraft.client.render.entity.EntityRendererPainting;
-import net.minecraft.client.render.entity.MobRendererPig;
-import net.minecraft.client.render.entity.MobRendererPlayer;
-import net.minecraft.client.render.entity.MobRendererScorpion;
-import net.minecraft.client.render.entity.MobRendererSheep;
-import net.minecraft.client.render.entity.MobRendererSlime;
-import net.minecraft.client.render.entity.EntityRendererSprite;
-import net.minecraft.client.render.entity.MobRendererSpider;
-import net.minecraft.client.render.entity.MobRendererSquid;
-import net.minecraft.client.render.entity.EntityRendererTNT;
-import net.minecraft.client.render.entity.MobRendererWolf;
 import net.minecraft.client.render.model.ModelPig;
 import net.minecraft.client.render.model.ModelSheepOverlay;
 import net.minecraft.client.render.model.ModelSheepWool;
@@ -102,8 +74,8 @@ public class EntityRenderDispatcher
         renderers.put(MobWolf.class, new MobRendererWolf(new ModelWolf(0.0f), 0.5F));
         renderers.put(MobChicken.class, new MobRendererChicken(new ModelChicken(), 0.3F));
         renderers.put(MobCreeper.class, new MobRendererCreeper());
-        renderers.put(MobSkeleton.class, new MobRendererBiped<>(new ModelSkeleton(), 0.5F));
-        renderers.put(MobZombie.class, new MobRendererBiped<>(new ModelZombie(), 0.5F));
+        renderers.put(MobSkeleton.class, new MobRendererBipedArmored<>(new ModelSkeleton(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
+        renderers.put(MobZombie.class, new MobRendererBipedArmored<>(new ModelZombie(), new ModelZombie(1.0f), new ModelZombie(0.5f), 0.5F));
         renderers.put(MobSnowman.class, new MobRendererBiped<>(new ModelZombie(), 0.5F));
         renderers.put(MobZombieArmored.class, new MobRendererZombieArmored(new ModelZombie(), 0.5F));
         renderers.put(MobSlime.class, new MobRendererSlime(new ModelSlime(16), new ModelSlime(0), 0.25F));
@@ -111,6 +83,7 @@ public class EntityRenderDispatcher
         renderers.put(MobHuman.class, new MobRendererHuman());
         renderers.put(MobGiant.class, new MobRendererGiant(new ModelZombie(), 0.5F, 6F));
         renderers.put(MobGhast.class, new MobRendererGhast());
+        renderers.put(MobGhastVehicle.class, new MobRendererGhast());
         renderers.put(MobSquid.class, new MobRendererSquid(new ModelSquid(), 0.7F));
         renderers.put(Mob.class, new MobRenderer<>(new ModelBiped(), 0.5F));
         renderers.put(Entity.class, new EntityRendererDefault());
@@ -129,7 +102,7 @@ public class EntityRenderDispatcher
         renderers.put(EntityLightning.class, new EntityRendererLightningBolt());
         renderers.put(ProjectileCannonball.class, new EntityRendererCannonball());
         renderers.put(ProjectilePebble.class, new EntityRendererSprite<ProjectilePebble>(Items.AMMO_PEBBLE));
-
+        renderers.put(MobButterfly.class, new MobRendererButterfly());
 
         for (EntityRenderer<?> renderer : renderers.values())
         {
